function BearbeiteBlock(Zahl: LongInt): string;
                                        { bearbeite 3er Block, d.h. 0 bis 999) }
const LangZiffern : array[0..9] of string=
                    ('','eins','zwei','drei','vier','fnf','sechs','sieben',
                     'acht','neun');    { ausgeschriebene Namen }
const KurzZiffern : array[0..9] of string=
                    ('','ein','zwei','drei','vier','fnf','sech','sieb',
                     'acht','neun');    { Kurzformen }

var Resultat  : string;                 { Zwischenspeicher }

begin
   Resultat:='';                        { initialisieren }

   if Zahl>=100 then                    { grer 100 ? }
   begin
      if Zahl div 100<>1 then           { falls Hunderterziffer<>1 Langnamen+"hundert" nehmen }
         Resultat:=Resultat+LangZiffern[Zahl div 100]+'hundert'
      else
         Resultat:=Resultat+'einhundert';{ Ausnahmefall 100=einhundert, da alle anderen Ziffern wie
                                           Langnamen, blo 100 hat Kurznamen (S fehlt bei einS) }
      Zahl:=Zahl mod 100;               { Hunderterziffer bearbeitet, nun entfernen }
   end;

   case Zahl of                         { Fallunterscheidung }
      0.. 9: Resultat:=Resultat+LangZiffern[Zahl];{ 0 bis 9 normale Langnamen }
         11: Resultat:=Resultat+'elf';  { Sonderfall 11 }
         12: Resultat:=Resultat+'zwlf';{ Sonderfall 12 }
     13..19: Resultat:=Resultat+KurzZiffern[Zahl mod 10]+'zehn';
                                        { 13 bis 19 Kurznamen+"zehn" }
        else                            { von 20 bis 99 }
        begin
           Resultat:=Resultat+LangZiffern[Zahl mod 10]+'und';
                                        { Einerziffer (als Langnamen) an die Zeichenkette anhngen +"und"}
           case Zahl div 10 of          { Zehnerziffer bersetzen }
                 1: Resultat:=Resultat+'zehn';{ Sonderfall 10 }
                 2: Resultat:=Resultat+'zwanzig';{ Sonderfall 20 }
                 3: Resultat:=Resultat+'dreiig';{ Sonderfall 30 }
              4..9: Resultat:=Resultat+KurzZiffern[Zahl div 10]+'zig';
                                        { Normalfall 40 bis 90: Kurzname+"zig" }
           end;
        end;
   end;

   BearbeiteBlock:=Resultat;            { den bersetzten 3er Block bergeben }
end;

var Eingabe : LongInt;                  { eingegebene Zahl }
    Ausgabe : string;                   { auszugebenes Wort }

begin
   write('Zu konvertierende Zahl : ');  { Zahl einlesen }
   readln(Eingabe);

   write(Eingabe:10,' ');               { Zahl ausgeben }

   if Eingabe>=1000 then                { falls >=1000 zwei 3er Blcke }
   begin
      Ausgabe:=BearbeiteBlock(Eingabe div 1000);
                                        { ersten 3er Block bearbeiten (ersten 3 Ziffern von 1000 bis 999999) }
      if (Eingabe div 1000) mod 100=1 then
                                        { Sonderfall x01: letztes S entfernen }
         delete(Ausgabe,length(Ausgabe),1);

      write(Ausgabe+'tausend');         { bersetztes Wort +"tausend" ausgeben }

      Eingabe:=Eingabe mod 1000;        { nchsten 3er Block bearbeiten }
   end;

   writeln(BearbeiteBlock(Eingabe));    { bersetzen und ausgeben }
end.